/**
 *
 * @authors M
 * @date    2017-07-08 00:13:00
 * 包含内容如下：
 * GobalConfig
 * Util
 */
(function (window) {
  var GobalConfig = {
    "domain":"http://119.29.216.25:8084",
    "debug": true,
    "appId": "88d2dfe7455748f8b7be4345cdfe929a",
    "productKey": ["ce902e31a890491c9395c439d5c3a34f","fcbd40f1aa04404eb193dc3f82125e7f","9dffc831c61b4504876acec2f39d4524"],
    "rawInstruction":[18,255,255,255,255,255,255,255,255,255,255,255,255,255]//获取全数据点时需先下发的原始指令
  }
  var Util = function() {
      var Deferred = function() {
          var _this = this;
          var deferred = $.Deferred();
          deferred.success = function() {
              // If you want to check out what the arguments you should consider,
              // please go to http://api.jquery.com/category/deferred-object/.
              deferred.done.apply(deferred, arguments);
              return deferred;
          };
          deferred.error = function() {
              Util.hideLoading();
              deferred.fail.apply(deferred, arguments);
              return deferred;
          };
          deferred.next = function() {
              deferred.then.apply(deferred, arguments);
              return deferred;
          };
          deferred.accept = function(tag) {
              _this.tag = tag;
              return deferred;
          }
          deferred.abort = function() {
              api.cancelAjax({
                  tag: _this.tag
              });
              _this.tag = null;
              deferred.reject(null);
              return deferred;
          }
          return deferred;
      };
      var isAndroid = (/android/gi).test(navigator.appVersion);
      var uzStorage = function() {
          var ls = window.localStorage;
          if (isAndroid) {
              ls = os.localStorage();
          }
          return ls;
      };

      //事件节流
      var throttle = function(fn, interval) {
          var _self = fn,
              timer,
              firstTime = true;
          return function() {
              var args = arguments,
                  _me = this;
              if (firstTime) {
                  _self.apply(_me, args);
                  return firstTime = false;
              }
              if (timer) {
                  return false;
              }
              timer = setTimeout(function() {
                  clearTimeout(timer);
                  timer = null;
                  _self.apply(_me, args);
              }, interval || 500);
          }
      };

      return {
          //事件节流
          throttle: throttle,

          //保存数据到LocalStorage
          setStorage: function(key, value) {
              if (arguments.length === 2) {
                  var v = value;
                  if (typeof v == 'object') {
                      v = JSON.stringify(v);
                      v = 'obj-' + v;
                  } else {
                      v = 'str-' + v;
                  }
                  var ls = uzStorage();
                  if (ls) {
                      ls.setItem(key, v);
                  }
              }
          },
          //根据key从LocalStorage获取数据
          getStorage: function(key) {
              var ls = uzStorage();
              if (ls) {
                  var v = ls.getItem(key);
                  if (!v) {
                      return;
                  }
                  if (v.indexOf('obj-') === 0) {
                      v = v.slice(4);
                      return JSON.parse(v);
                  } else if (v.indexOf('str-') === 0) {
                      return v.slice(4);
                  }
              }
          },
          /**
           * 清除LocalStorage数据
           * 若key定义，则清除关键字key的数据
           * 若key未定义，则清除所有的数据
           ***/
          clearStorage: function(key) {
              var ls = uzStorage();
              if (ls) {
                  if (key) {
                      ls.removeItem(key);
                  } else {
                      ls.clear();
                  }
              }
          },

          //展示Loading对话框
          showLoading: function(title) {
              api.showProgress({
                  style: 'default',
                  animationType: 'fade',
                  title: title,
                  modal: true
              });
          },
          //隐藏Loading对话框
          hideLoading: function() {
              api.hideProgress();
          },
          //自定义显示进度提示框
          showProgress: function(option) {
              var showProgressDefult = {
                  style: 'default', //（可选项）进度提示框风格（详见进度提示框风格常量）
                  animationType: 'fade', //（可选项）进度提示框动画类型（详见进度提示框动画类型常量）
                  title: '', //（可选项）标题
                  text: '请稍后...', //（可选项）内容
                  modal: false //（可选项）是否模态，模态时整个页面将不可交互
              };
              var option = $.extend(showProgressDefult, option);
              api.showProgress(option);
          },

          //自定义弹出一个定时自动关闭的提示框
          toast: function(option) {
              var toastOption = {
                  msg: '', //弹出的提示语消息
                  duration: 3000, //（可选项）持续时长，单位：毫秒
                  location: 'bottom' //（可选项）弹出位置，顶部、中间或底部（
              };
              if (typeof (option) === 'string') {
                toastOption.msg = option
              } else {
                toastOption = $.extend(true, toastOption, option)
              }
              api.toast(toastOption);
          },
          //自定义弹出框
          alert: function(option) {
              var alertOption = {
                  title: '温馨提示', //（可选项）标题
                  msg: '' //（可选项）内容
              };
              if (typeof(option) == 'string') {
                  alertOption.msg = option;
              } else {
                  alertOption = $.extend(alertOption, option);
              }
              api.alert(alertOption);
          },
          // 确认弹出框
          confirm: function(option, callback) {
              var defaultOption = {
                  title: '温馨提示', //（可选项）标题
                  msg: '是否确认？', //（可选项）内容
                  buttons: ['确定', '取消']
              };
              if (typeof(option) == 'string') {
                  defaultOption.msg = option;
                  var option = defaultOption;
              } else {
                  var option = $.extend(defaultOption, option);
              }
              api.confirm(option, callback);
          },

          // 自定义打开window
          openWin: function(option) {
              var myDefault = {
                  name: '', //window名字，不能为空字符串
                  url: '', //页面地址，可以为本地文件路径，支持相对路径和绝对路径，以及widget://、fs://等协议路径，也可以为远程地址
                  pageParam: {}, //（可选项）页面参数，新页面中可以通过api.pageParam获取
                  bounces: false, //若在config.xml里面配置了pageBounce，则默认值为配置的值，否则为false （可选项）页面是否弹动
                  vScrollBarEnabled: false, //（可选项）是否显示垂直滚动条
                  hScrollBarEnabled: false, //（可选项）是否显示水平滚动条
                  scaleEnabled: false, //（可选项）页面是否可以缩放，为true时softInputMode参数无效
                  slidBackEnabled: true, //（可选项）是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只iOS有效
                  slidBackType: 'full', //（可选项）当支持滑动返回时，设置手指在页面右滑的有效作用区域。取值范围（full:整个页面范围都可以右滑返回，edge:在页面左边缘右滑才可以返回），该字段只iOS有效
                  animation: {}, //（可选项）动画参数，不传时使用默认动画，type：动画类型，subType：动画子类型。
                  showProgress: false, //（可选项）是否显示等待框，只在url为网址时有效
                  delay: 0, //（可选项）window显示延迟时间，适用于将被打开的window中可能需要打开有耗时操作的模块时，可延迟window展示到屏幕的时间，保持UI的整体性
                  reload: false, //描述：（可选项）页面已经打开时，是否重新加载页面，重新加载页面后apiready方法将会被执行
                  allowEdit: false, //（可选项）是否允许长按页面时弹出选择菜单
                  softInputMode: 'auto' //（可选项）当键盘弹出时，输入框被盖住时，当前页面的调整方式，详见键盘弹出页面调整方式常量；只iOS有效，且当scaleEnabled参数为true时无效，Android请在config.xml里面配置并云编译使用
              };
              var option = $.extend(true, myDefault, option);
              api.openWin(option);
          },
          // 关闭window
          closeWin: function(option) {
              if (option) {
                  var myDefault = {
                      name: '', //window名字，不能为空字符串
                      animation: {
                          type: "none", //动画类型（详见动画类型常量）
                          subType: "from_right", //动画子类型（详见动画子类型常量）
                          duration: 300 //动画过渡时间，默认300毫秒
                      }
                  };
                  var option = $.extend(true, myDefault, option);
                  api.closeWin(option);
              } else {
                  api.closeWin();
              }
          },
          // 关闭窗体到指定窗口
          closeToWin: function(name) {
              api.closeToWin({
                  name: name || null
              });
          },

          // 自定义打开frame
          openFrame: function(option) {
              var myDefault = {
                  rect: {
                      x: 0,
                      y: 0,
                      w: api.winWidth,
                      h: api.winHeight
                  },
                  reload: true,
                  bounces: false, //若在config.xml里面配置了pageBounce，则默认值为配置的值，否则为false （可选项）页面是否弹动
                  bgColor: 'rgba(0,0,0,0)',
                  vScrollBarEnabled: false, //（可选项）是否显示垂直滚动条
                  hScrollBarEnabled: false //（可选项）是否显示水平滚动条
              };
              var option = $.extend(true, myDefault, option);
              api.openFrame(option);
          },
          // 关闭窗体的子页面
          closeFrame: function(name) {
              api.closeFrame({
                  name: name || null
              });
          },

          // 事件监听
          onEventListener: function (name, callback) {
            api.addEventListener({
              name: name
            }, callback);
          },
          // 移除事件监听
          removeEventListener: function (name) {
            api.removeEventListener({
                name: name
            });
          },

          // 关闭系统事件监听
          closeSystemLinstener: function(name) {
              /*监听手机返回键*/
              api.addEventListener({
                  name: 'keyback'
              }, function(ret, err) {
                  api.execScript({ ///在指定页面中执行srcipt中脚本
                      name: name, ///打开外部网页的Win名
                      script: 'api.historyBack(function(ret, err) {if(!ret.status){api.closeWidget();}});'
                  });
              });
          },

          //发送震动效果
          vibrate: function() {
              api.notification({
                  vibrate: [70, 70],
                  sound: ''
              }, function(ret, err) {
                  var id = ret.id;
              });
          },

          // 打印信息
          info: function() {
              if (GobalConfig.debug) {
                  if (arguments.length === 1) {
                      console.info(JSON.stringify(arguments[0]));
                  } else {
                      console.info(arguments[0] + JSON.stringify(arguments[1]));
                  }
              }
          },
          // 打印日志
          log: function() {
              var now = new Date();
              var log = "";
              if (arguments.length === 1) {
                  var log = ['App-Log:', JSON.stringify(arguments[0]), " ", now.toString()].join("");
              } else {
                  var log = ['App-Log:', arguments[0], JSON.stringify(arguments[1]), " ", now.toString()].join("");
              }
              console.log(log);
          },

          // 克隆Json
          cloneJSON: function(json) {
              return JSON.parse(JSON.stringify(json));
          },

          // 是不是空对象
          isEmptyObject: function(obj) {
              if(JSON.stringify(obj) === '{}'){
                  return true;
              }
              return false;
          },


          // 设置页面大小
          setWrapperSize: function() {
              var clientHeight = document.body.clientHeight;
              var pageWrapper = document.getElementsByClassName("page-wrapper");
              if (pageWrapper.length > 0) {
                  pageWrapper[0].style.height = clientHeight + "px";
              }
          },

          // 处理ios7以及android4.4以上版本的状态栏
          fixStatusBar: function() {
              var element = document.getElementById('fix-status-bar');
              var systemType = api.systemType;
              var systemVersion = api.systemVersion;
              var fullScreen = api.fullScreen;
              var statusBarAppearance = api.statusBarAppearance;
              if (systemType == 'ios') {
                  var numSystemVersion = parseInt(systemVersion, 10);
                  if (numSystemVersion >= 7 && !fullScreen && statusBarAppearance) {
                      element.style.paddingTop = '20px';
                  }
              } else if (systemType == 'android') {
                  var numSystemVersion = parseFloat(systemVersion);
                  if (numSystemVersion >= 4.4 && !fullScreen && statusBarAppearance) {
                      element.style.paddingTop = '20px';
                  }
              }
          },

          // 获取URL的参数
          getUrlParams: function(url) {
              if (url) {
                  var _url = document.createElement('a');
                  _url.href = url;
                  var urlPathName = _url.pathname;
                  var urlSearch = _url.search;
              } else {
                  var urlPathName = window.location.pathname;
                  var urlSearch = window.location.search;
              }
              var params = new Object();
              if (urlSearch.indexOf("?") != -1) {
                  var paramsString = urlSearch.substr(1);
                  var paramsList = paramsString.split("&");
                  for (var i = 0; i < paramsList.length; i++) {
                      params[paramsList[i].split("=")[0]] = unescape(paramsList[i].split("=")[1]);
                  }
              }
              var lastPathName = urlPathName.split("/").pop();
              if (lastPathName) {
                  params[":param"] = lastPathName;
              }
              return params;
          },

          doDecode: function(str) {
              var decode = window.atob(str || "");
              // var decode = decodeURIComponent(str || "");
              var code = "";
              for (var i = 0; i < decode.length; i++) {
                  temp = decode.charCodeAt(i).toString(16);
                  code += "" + new Array(3 - temp.length).join("0") + temp;
              }
              return code;
          },

          /**
           * 网络请求
           *
           **/
          //检查Token
          checkToken: function(callback) {
              var _this = this;
              var expiresAt = _this.getStorage("expiresAt");
              var now = new Date();
              var nowTime = now.getTime();
              if (nowTime >= expiresAt * 1000) {
                  var requestParams = {
                      "body": {
                          "userId": _this.getStorage("user").userId,
                          "refreshToken": _this.getStorage("refreshToken")
                      }
                  };
                  var Domain = GobalConfig.wapu_domain;
                  _this.post(Domain + "/sys/appUser/refresh_token", requestParams).success(function(response) {
                      if (response.code == 200) {
                          if (callback instanceof Function) {
                              callback();
                          }
                      } else {
                          _this.hideLoading();
                          _this.clearStorage();
                          setTimeout(function() {
                              _this.openWin({
                                  name: 'signIn',
                                  url: './sign_in.html',
                                  reload: true
                              });
                          }, 500);
                          _this.toast("重新登录！");
                      }
                  });
              } else {
                  if (callback instanceof Function) {
                      callback();
                  }
              }
          },
          // 请求
          ajax: function(options) {
              var _this = this;
              var deferred = new Deferred();
              if (api.connectionType != "none") {
                  var settings = $.extend(true, {
                      tag: Math.random().toString(36).substring(3, 8),
                      headers: {
                          "Content-Type": "application/json;charset=UTF-8",
                          "Client-Id": api.deviceId,
                          "App-Version": api.appVersion,
                          "OS": api.systemVersion,
                          "Device": api.deviceModel,
                          "Authorization": _this.getStorage("accessToken") || null
                      }
                  }, options);
                  var requestParams = {
                      "body": {
                        "appKey":"xiding",
                        "data": settings.data.body,
                        "version": "1.0"
                      }
                  };
                  settings.data = requestParams;
                  _this.log("Ajax Request:", settings);
                  var callback = function(response, error) {
                      _this.log("Ajax Response:", response);
                      if (response) {
                          deferred.resolve(response);
                      } else {
                          _this.log("Ajax Error:", error);
                          _this.hideLoading();
                          _this.toast(error.msg);
                          deferred.reject(error);
                      }
                  }
                  deferred.accept(settings.tag);
                  if (settings.url.indexOf("refresh_token") >= 0 || settings.url.indexOf("login")) {
                      api.ajax(settings, callback);
                  } else {
                      _this.checkToken(function() {
                          api.ajax(settings, callback);
                      });
                  }
              } else {
                  _this.hideLoading();
                  _this.toast("当前网络异常，请检查网络后再试");
              }
              return deferred;
          },
          get: function(url, data) {
              return this.ajax({
                  "url": url,
                  "method": "get",
                  "data": data || {},
              });
          },
          post: function(url, data) {
              return this.ajax({
                  "url": url,
                  "method": "post",
                  "data": data || {},
              });
          },
          put: function(url, data) {
              return this.ajax({
                  "url": url,
                  "method": "put",
                  "data": data || {},
              });
          },
          delete: function(url, data) {
              return this.ajax({
                  "url": url,
                  "method": "delete",
                  "data": data || {},
              });
          },
          //处理返回数据
          handleResponse: function(response, success, error) {
              if (response.code == 200) {
                  if (success && success instanceof Function) {
                      success.call(null, response);
                  }
              } else {
                  if (response.code == 505 || response.code == 10005 || response.code == 10007) {
                      setTimeout(function() {
                          Util.clearSignInInfo();
                          Util.openWin({
                              name: 'signIn',
                              url: './sign_in.html'
                          });
                      }, 200);
                      return false;
                  }
                  if (typeof(error) == "undefined") {
                      Util.toast(response.message || "请求服务器失败");
                  } else {
                      if (error && error instanceof Function) {
                          error.call(null, response);
                      }
                  }
              }
          },


          //保存操作设备的uid和Token信息
          saveDeviceUidTokenInfo: function(uid, token) {
              this.setStorage("deviceUid", uid);
              this.setStorage("deviceToken", token);
          },
          //获取操作设备的uid和Token信息
          getDeviceUidTokenInfo: function() {
              return {
                  uid: this.getStorage("deviceUid"),
                  token: this.getStorage("deviceToken")
              };
          },
          //保存接口Token相关性信息
          saveTokenInfo: function(accessToken, refreshToken, expiresAt) {
              this.setStorage("accessToken", accessToken);
              this.setStorage("refreshToken", refreshToken);
              this.setStorage("expiresAt", expiresAt);
          },

          //保存用户信息
          saveUserInfo: function(user) {
              this.setStorage("user", user);
          },
          //保存机智云的token和uid
          saveGizwtisInfo: function(gizwits) {
              this.setStorage("gizwits", gizwits);
          },

          // 清楚已登录信息
          clearSignInInfo: function () {
              this.clearStorage('accessToken');
              this.clearStorage('refreshToken');
              this.clearStorage('expiresAt');
              this.clearStorage("user");
          },
          //初始化
          init: function(callback) {
              var _this = this;
              //处理ios7以及android4.4以上版本的状态栏
              _this.fixStatusBar();

              //设置Pagewrapper大小
              _this.setWrapperSize();

              // 监听网络连接
              _this.onEventListener('online', function(ret, err) {
                  var connectionType = ret.connectionType;
                  _this.toast('网络已连接：' + connectionType);
              })

              //监听网络断开
              _this.onEventListener('offline', function(ret, err) {
                  _this.hideLoading();
                  _this.toast("当前网络异常，请检查网络");
              })

              if (callback instanceof Function) {
                callback();
              }
          }
      }
  }();
  window.Util = Util
  window.GobalConfig = GobalConfig
})(window)
